/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function IO_file_fileHandler		//<c><a>protected<d>File handler class
(
_instantiator		//<p>IO_file_Instantiator<d>File mediator instance
){
//================
this.IO_file_fileHandler = function		//<m>void<a>private<d>class constructor
(
instantiator		//<p>IO_file_Instantiator<d>File mediator instance
){
this.className		= 'IO_file_fileHandler';
this.instantiator	= instantiator;
this.setIn();
}//</m>IO_file_fileHandler



//================
this.setIn = function		//<m>void<a>private<d>Instance i12n
(){
this.errorNotifier	= new ERROR_Notifier(this.className);
this.mode			=
this.permissions	=
this.behaviour		=
this.streamReady	=
this.lineIterator	= null;
}//</m>setIn



//================
this.set_mode = function		//<m>int<a>protected<d>Set up mode member
(
mode		//<p>string=RDWR_MODE<d>Mode code --optional
){
this.mode = mode || this.K.RDWR_MODE;
}//</m>set_mode



//================
this.set_permissions = function		//<m>int<a>protected<d>Set up permissions member
(
permissions		//<p>string<d>Permission code
){
this.permissions = permissions;
}//</m>set_permissions



//================
this.set_behaviour = function		//<m>int<a>protected<d>Set up behaviour member
(
behaviour		//<p>string<d>Behaviour code
){
this.behaviour = behaviour;
}//</m>set_behaviour



//================
this.setStream = function		//<m><a>private<d>Set up input or output stream
(
outcoming		//<p>boolean=false<d>Stream direction: output : input --optional
){
var
/*string*/member, method,
/*int*/code;
if(outcoming){	//output
	member = 'outputStream';
	this.set_behaviour(null);
	code = this.K.ERROR.WRITE_DENY;
	}
else{	//input
	member = 'inputStream';
	this.set_behaviour(this.K.CLOSE_ON_EOF);
	code = this.K.ERROR.READ_DENY;
	}
try{
	this.instantiator[member].init(this.handle, this.mode, this.permissions, this.behaviour);
	this.streamReady = true;
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR[code]);
	}
}//</m>setStream



//================
this.setOut = function		//<m>int<a>public<d>Set up (create) file content
(
content,		//<p>string<d>File content to write
permissions		//<p>int<d>Permission code
){
try{
	this.set_permissions(permissions);
	if(this.setStream(this.K.OUTPUT_STREAM) != this.K.ERROR.NONE) return this.K.ERROR.WRITE_DENY;
	return this.setOutput(content);
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.WRITE_DENY);
	}
}//</m>setOut



//================
this.setOutMake = function		//<m>int<a>private<d>Setup (make) a file
(
permissions		//<p>int<d>Permission code
){
try{
	this.set_permissions(permissions);
	this.handle.create(this.K.FILE_INSTANCE, this.permissions);
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.MAKE_DENY);
	}
}//</m>setOutMake



//================
this.setOutput = function		//<m>int<a>private<d>Set up (create) file content
(
content		//<p>string<d>File content to write
){
try{
	var
	outputStream = XPConnector.getQuery('nsIOutputStream', this.instantiator.outputStream);
    outputStream.write(content, content.length);
    outputStream.flush();
	//if(!(this.mode & this.K.APPEND_MODE)) outputStream.close();		//FIXME: SHOULD WE CLOSE ?
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.STREAM_DENY);
	}
}//</m>setOutput



//================
this.setLineIterator = function		//<m>int<a>private<d>Set up lineIterator member
(){
this.instantiator.scriptInputStream.init(this.instantiator.inputStream);
this.lineIterator = new IO_file_LineIterator(this.instantiator.scriptInputStream);
return this.lineIterator.setUp() ? this.K.ERROR.NONE : this.K.ERROR.NO_SUCCESS;
}//</m>setLineIterator



//================
this.get_mode = function		//<m>int<a>protected<d>Get mode member
(){
return this.mode;
}//</m>get_mode



//================
this.getIn = function		//<m>int<a>private<d>Get the content of the handled file
(
size,			//<p>int<d>File size to read
permissions		//<p>int<d>Permission code
){
this.set_permissions(permissions);
return this.testInputStream() ? this.getInput(size) : null;
}//</m>getIn



//================
this.getLineIn = function		//<m>int<a>public<d>Get a line of the handled file
(
step		//<p>int=1<d>Number of line to step forward --optional
){
if(!this.testInputStream()) return null;
if(!this.lineIterator && (this.setLineIterator() != this.K.ERROR.NONE)) return null;
return this.lineIterator.getNext(step);
}//</m>getLineIn



//================
this.getInput = function		//<m>string<a>public<d>Get the input stream
(
size		//<p>int<d>File size to read
){
try{
	this.instantiator.scriptInputStream.init(this.instantiator.inputStream);
	return this.instantiator.scriptInputStream.read(size);
	}
catch(e){
	this.errorNotifier.setOut(e, this.K.ERROR.READ_DENY);
	return null;
	}
}//</m>getInput



//================
this.testInputStream = function		//<m>int<a>private<d>Get the content of the handled file
(){
try{
	return (!this.streamReady && (this.setStream(this.K.INPUT_STREAM) != this.K.ERROR.NONE)) ? false : true;
	}
catch(e){
	this.errorNotifier.setOut(e, this.K.ERROR.READ_DENY);
	return false;
	}
}//</m>testInputStream



this.K =
	{
	FILE_INSTANCE:				0,		//synchronise with XPCOM_nsIFile NORMAL_TYPE
	DIR_INSTANCE:				1,		//synchronise with XPCOM_nsIFile DIRECTORY_TYPE

	RDONLY_MODE:				0x01,
	WRONLY_MODE:				0x02,
	RDWR_MODE:					0x04,
	CREATE_MODE:				0x08,
	APPEND_MODE:				0x10,
	TRUNCATE_MODE:				0x20,
	
	CLOSE_ON_EOF:				1<<2,
	DELETE_ON_CLOSE:			1<<1,
	REOPEN_ON_REWIND:			1<<3,

	INPUT_STREAM:				0,		//false
	OUTPUT_STREAM:				1,		//true
	TRANSPORT_AUTO_CLOSE:		true,
	STREAM_NON_BLOCKING:		0,
	STREAM_BLOCKING:			1,
	STREAM_SEGMENT_SIZE:		0,		//default
	STREAM_SEGMENT_COUNT:		0,		//default

	CLOSE_STREAM_AT_DONE:		true,
	NO_OFFSET:					0,
	

	ERROR:
		{
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,

		//FATAL
		MAKE_DENY:				-1,
		READ_DENY:				-2,
		WRITE_DENY:				-3,
		EXEC_DENY:				-4,
		STREAM_DENY:			-8,
		FATAL:					0xFF	//end of error codes
		}
	};



this.IO_file_fileHandler(_instantiator);
}//</c>IO_file_fileHandler<d>&
/*
This component class manages handled file operations:
	input to read file content,
	output to write file content
*/

