/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function RDFAPI_Literal		//<c><a>protected<d>RDF literal class
(
_source			//<p>Object<d>Literal node or literal
){
const ASSERTING = false;
//================
this.RDFAPI_Literal = function		//<m>void<a>private<d>class constructor
(
source				//<p>Object<d>Literal node or literal
){
this.prototype = RDFAPI_Node;
this.prototype(source);
this.className	= 'RDFAPI_Literal';
//i12n
this.dateFormatter	= new DATETIME_Formatter();
this.set_type();
this.set_node();
}//</m>RDFAPI_Literal



//================
this.set_type = function		//<m>void<a>private<d>Set up the type member according to its source type
(){
switch(LANG_object_getType(this.source)){
	case TYPEOF_INT:
		this.type = this.K.rsc.INT_LITERAL_NODE;
		break;
	case TYPEOF_ISODATE:
		this.type = this.K.rsc.DATE_LITERAL_NODE;
		break;
	case TYPEOF_OBJECT:
		this.type = this.K.rsc.INSTANCE_RESOURCE;
		break;
	default:
		this.type = this.K.rsc.STRING_LITERAL_NODE;		//TYPEOF_FLOAT or TYPEOF_STRING
	}	//---switch
//__ASSERT__.warn('RDFAPI_Literal.set_type: this.source == ' + this.source, ASSERTING);
//__ASSERT__.warn('RDFAPI_Literal.set_type: typeOf this.source == ' + LANG_object_getType(this.source), ASSERTING);
//__ASSERT__.warn('RDFAPI_Literal.set_type: this.type == ' + this.type, ASSERTING);
}//</m>set_type



//================
this.set_node = function		//<m>(boolean)int<a>private<d>Set up node member accroding to its type
(){
var
/*string*/method;
switch(this.type){
	case 0:		//INSTANCE_RESOURCE
		this.node = this.source;
		this.set_type(this.source.Value);	//redo typing
		return;
	case 9:		//INT_LITERAL_NODE
		method = 'GetIntLiteral';
		break;
	case 10:	//DATE_LITERAL_NODE
		method = 'GetDateLiteral';
		this.set_source(this.dateFormatter.getISO2UTC(this.source));
		break;
	default:	//STRING_LITERAL_NODE
		method = 'GetLiteral';
		break;		
	}	//---switch
try{
	this.node = this.XPCOM_RDFService[method](this.source);
	//__ASSERT__.warn('RDFAPI_Literal.set_node: this.node == ' + this.node, ASSERTING);
	return this.K.ERROR.NONE
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.SERVICE_ACCESS);
	}
}//</m>set_node



//================
this.getURI =
this.getLabel = function		//<m>string<a>public<d>Get the content of the node
(){
try{
	var
	/*any*/label = this.getAsNode().Value;
	return (this.type == this.K.rsc.DATE_LITERAL_NODE) ? this.dateFormatter.getUTC2ISO(label) : label;
	}
catch(e){
	return;		//undefined
	}
}//</m>getLabel<d>&
/*
RDF API
*/



//================
this.getAsLiteral = function		//<m>Object<a>public<d>Cast a nsIRDFNode to a nsIRDFLiteral
(){
var
/*string*/component = (this.type == this.K.rsc.INT_LITERAL_NODE) ? 'nsIRDFInt' :
	(this.type == this.K.rsc.DATE_LITERAL_NODE) ? 'nsIRDFDate' : 'nsIRDFLiteral';
return this.getInterface(component);
}//</m>getAsLiteral



this.RDFAPI_Literal(_source);
}//</c>RDFAPI_Literal

