/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function RDFAPI_Statement		//<c><a>protected<d>RDF statement class
(
_predicate,		//<p>RDFAPI_Resource<d>Predicate node
_subject,		//<p>RDFAPI_Resource<d>Subject node
_object			//<p>RDFAPI_Resource<d>Object node
){
const ASSERTING = false;
//================
this.RDFAPI_Statement = function		//<m>void<a>private<d>class constructor
(
predicate,		//<p>RDFAPI_Resource<d>Predicate RDFAPI_Resource instance or nsIRDFResource or URI string
subject,		//<p>RDFAPI_Resource<d>Subject RDFAPI_Resource instance or nsIRDFResource or URI string
object			//<p>RDFAPI_Resource<d>Object RDFAPI_Resource instance or nsIRDFNode or literal string
){
this.prototype = RDFAPI_NSRDF;
this.prototype();
this.className	= 'RDFAPI_Statement';
//i12n
if(!this.testService()) return;
const
/*boolean*/AS_STATEMENT_OBJECT = true;
this.predicate = this.getFromSource(predicate);
this.subject = this.getFromSource(subject);
this.object = this.getFromSource(object, AS_STATEMENT_OBJECT);
this.URI = '';
//this.set_URI();		//no auto setting (time consuming)
}//</m>RDFAPI_Statement



//================
this.set_URI = function		//<m>void<a>private<d>Set up an URI for the statement
(){
if(!this.MD5Generator) this.MD5Generator = new DIGEST_MD5Generator();
this.URI = this.MD5Generator.getHex(this.predicate.getURI() + this.subject.getURI() + this.object.getURI());
return;
//skip this time consuming algorythm
this.URI = this.MD5Generator.getXORDigest(
	this.MD5Generator.getHex(this.predicate.getURI()),
	this.MD5Generator.getXORDigest(
		this.MD5Generator.getHex(this.subject.getURI()),
		this.MD5Generator.getHex(this.object.getURI())));
}//</m>set_URI<d>&
/*
URI is computed by MD5 digest of concatening predicate, subject and object
URI is computed by XORing predicate, subject and object MD5 digests (skip)
*/



//================
this.set_subject = function		//<m>void<a>public<d>Replaces the subject of the statement
(
subject		//<p>RDFAPI_Resource<d>Replacing subject
){
this.subject = subject;
}//</m>set_subject



//================
this.set_object = function		//<m>void<a>public<d>Replaces the object of the statement
(
object		//<p>RDFAPI_Resource<d>Replacing object
){
this.object = object;
}//</m>set_object



//================
this.getURI = function		//<m>void<a>public<d>Get the URI member
(){
return this.URI;
}//</m>getURI<d>&
/*
RDF API
*/



//================
this.getPredicate = function		//<m>RDFAPI_Resource<a>public<d>Get predicate member
(){
return this.predicate;
}//</m>getPredicate<d>&
/*
RDF API is predicate
*/



//================
this.getPredicateAsResource = function		//<m>RDFAPI_Resource<a>public<d>Get predicate resource
(){
return this.predicate.getAsResource();
}//</m>getPredicateAsResource



//================
this.getPredicateURI = function		//<m>string<a>public<d>Get predicate URI
(){
return this.predicate.getURI();
}//</m>getPredicate



//================
this.getSubject = function		//<m>RDFAPI_Resource<a>public<d>Get subject member
(){
return this.subject;
}//</m>getSubject<d>&
/*
RDF API is subject
*/



//================
this.getSubjectAsResource = function		//<m>Object<a>public<d>Get subject nsIRDFResource
(){
return this.subject.getAsResource();
}//</m>getSubjectAsResource



//================
this.getSubjectURI = function		//<m>string<a>public<d>Get subject URI
(){
return this.subject.getURI();
}//</m>getSubject



//================
this.getObject = function		//<m>RDFAPI_Resource<a>public<d>Get object member
(){
return this.object;
}//</m>getObject<d>&
/*
RDF API is object
*/



//================
this.getObjectAsNode = function		//<m>nsIResource<a>public<d>Get object resource
(){
return this.object.getAsNode();
}//</m>getObjectAsResource



//================
this.getObjectAsResource = function		//<m>nsIResource<a>public<d>Get object resource
(){
return this.object[(this.object instanceof RDFAPI_Literal) ? 'getAsLiteral' : 'getAsResource']();
}//</m>getObjectAsResource



//================
this.getObjectURI = function		//<m>string<a>public<d>Get object URI or label
(){
return this.object.getURI();
}//</m>getObject



//================
this.getFromSource = function		//<m>string<a>private<d>Create an RDFAPI_Literal or RDFAPI_Resource object
(
source,			//<p>RDFAPI_Resource<d>Resource node or Literal
objectifying	//<p>boolean=false<d>Object flag: get an object resource or literal || get a subject/predicate resource
){
if((source instanceof RDFAPI_Literal) || (source instanceof RDFAPI_Resource)) return source;
if(objectifying &&
(((typeof source) == 'string') || !(source instanceof Components.interfaces.nsIRDFResource))) return new RDFAPI_Literal(source);
return new RDFAPI_Resource(source, ((typeof source) == 'string') ? this.K.rsc.NAMED_RESOURCE : this.K.rsc.INSTANCE_RESOURCE);
}//</m>getFromSource



//================
this.getAsResource = function		//<m>RDFAPI_Statement<a>public<d>Reify the statement
(
prefix		//<p>string<d>URI prefix
){
//NOT IMPLEMENTED
}//</m>getAsResource



//================
this.testEquality = function		//<m>boolean<a>public<d>Check whether the statement is the same as  this one
(
statement		//<p>RDFAPI_Statement<d>Statement to compare
){
try{
	return (!statement ||
		!(statement instanceof RDFAPI_Statement) ||
		!(this.subject.testEquality(statement.getSubjectAsResource(), RDFAPI_Resource) &&
		this.predicate.testEquality(statement.getPredicateAsResource(), RDFAPI_Resource) &&
		this.object.testEquality(statement.getObjectAsResource(), RDFAPI_Resource))) ?
		false : true;
	}
catch(e){
	return false;
	}
}//</m>testEquality



this.RDFAPI_Statement(_predicate, _subject, _object);
}//</c>RDFAPI_Statement

