/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function RDFAPI_StatementObserver		//<c><a>protected<d>Model statement observer class
(
_referrer		//<p>RDFAPI_Model<d>Callback reference instance (must provide a setHandleObserver method)
){
//================
this.RDFAPI_StatementObserver = function		//<m>void<a>private<d>class constructor
(
referrer		//<p>Object<d>Callback reference
){
this.className	= 'RDFAPI_StatementObserver';
this.referrer	= referrer;
this.set_RDFAPI_StatementObserver();
}//</m>RDFAPI_StatementObserver



//================
this.set_RDFAPI_StatementObserver = function		//<m>void<a>private<d>Instance i12n
(){
this.notifier =
	{
	className:	this.className,
	event:		null,
	model:		null,	//batch update event
	statement:	null,	//statement event
	obsolete:	null	//statement modify event
	};
}//</m>set_RDFAPI_StatementObserver



//================
this.setNotifier = function		//<m>void<a>private<d>Notifier i12n
(
event,			//<p>Object<d>Loading event
statement,		//<p>RDFAPI_Statement<d>Statement instance -- optional
obsolete		//<p>Object<d>Obsolete object node -- optional
){
this.notifier.event		= event;
this.notifier.statement	= statement;
this.notifier.obsolete	= obsolete;
this.referrer.setHandleObserver(this.notifier);
}//</m>setNotifier



//================
this.onAssert = function		//<m>void<a>protected<d>Statement handler
(
model,			//<p>Object<d>Observed model
subject,		//<p>Object<d>Subject node
predicate,		//<p>Object<d>Predicate node
object			//<p>Object<d>Object node
){
this.setNotifier('onAssert', new RDFAPI_Statement(predicate, subject, object));
}//</m>onAssert



//================
this.onUnassert = function		//<m>void<a>protected<d>Statement handler
(
model,			//<p>Object<d>Observed model
subject,		//<p>Object<d>Subject node
predicate,		//<p>Object<d>Predicate node
object			//<p>Object<d>Object node
){
this.setNotifier('onUnassert', new RDFAPI_Statement(predicate, subject, object));
}//</m>onUnassert



//================
this.onChange = function		//<m>void<a>protected<d>Statement handler
(
model,			//<p>Object<d>Observed model
subject,		//<p>Object<d>Subject node
predicate,		//<p>Object<d>Predicate node
obsolete,		//<p>Object<d>Obsolete object node
object			//<p>Object<d>Changing object node
){
this.setNotifier('onChange', new RDFAPI_Statement(predicate, subject, object), obsolete);
}//</m>onChange



//================
this.onMove = function		//<m>void<a>protected<d>Statement handler
(
model,			//<p>Object<d>Observed model
obsolete,		//<p>Object<d>Obsolete subject node
subject,		//<p>Object<d>Subject node
predicate,		//<p>Object<d>Predicate node
object			//<p>Object<d>Object node
){
this.setNotifier('onMove',  new RDFAPI_Statement(predicate, subject, object), obsolete);
}//</m>onMove



//================
this.beginUpdateBatch = function		//<m>void<a>protected<d>Statement handler
(
model		//<p>Object<d>Observed model
){
this.notifier.model = model;
this.setNotifier('beginUpdateBatch');
}//</m>beginUpdateBatch



//================
this.endUpdateBatch = function		//<m>void<a>protected<d>Statement handler
(
model		//<p>Object<d>Observed model
){
this.notifier.model = model;
this.setNotifier('endUpdateBatch');
}//</m>endUpdateBatch



this.RDFAPI_StatementObserver(_referrer);
}//</c>RDFAPI_StatementObserver<d>&
/*
Implements XPCOM nsIRDFObserver
*/

